package com.andengine.entity.shape;

import javax.microedition.khronos.opengles.GL11;

import com.andengine.entity.primitive.EllipseVertexBuffer;

public abstract class BaseEllipse extends EllipticalShape {
	// ===========================================================
	// Constants
	// ===========================================================

	// ===========================================================
	// Fields
	// ===========================================================

	// ===========================================================
	// Constructors
	// ===========================================================

	public BaseEllipse(final float pX, final float pY, final float pRadius1, final float pRadius2) {
		super(pX, pY, pRadius1, pRadius2, new EllipseVertexBuffer(GL11.GL_STATIC_DRAW));
		this.updateVertexBuffer();
	}

	public BaseEllipse(final float pX, final float pY, final float pRadius1, final float pRadius2, final EllipseVertexBuffer pEllipseVertexBuffer) {
		super(pX, pY, pRadius1, pRadius2, pEllipseVertexBuffer);
	}

	// ===========================================================
	// Getter & Setter
	// ===========================================================

	// ===========================================================
	// Methods for/from SuperClass/Interfaces
	// ===========================================================

	@Override
	public EllipseVertexBuffer getVertexBuffer() {
		return (EllipseVertexBuffer)super.getVertexBuffer();
	}

	@Override
	protected void onUpdateVertexBuffer(){
		this.getVertexBuffer().update(this.mWidth, this.mHeight);
	}

	// ===========================================================
	// Methods
	// ===========================================================

	// ===========================================================
	// Inner and Anonymous Classes
	// ===========================================================
}